@echo off

setlocal

set compiler=compiler.exe
set directory=compiler0

for /f "delims=: tokens=2" %%a in ('chcp') do set code_page=%%a
if "%code_page:~0,1%" == " " set code_page=%code_page:~1%

if exist %compiler% if exist %~nx0 goto nocd
cd /d "%~dp0"
if exist %compiler% if exist %~nx0 goto nocd
if exist %directory%\nul cd %directory%
if exist %compiler% if exist %~nx0 goto nocd
if not "%~1" == "" if exist %~nx1\nul cd /d "%~nx1"
if not "%~1" == "" if exist %~dp1\nul cd /d "%~dp1"
if exist %compiler% goto nocd
call     :select_writeln "G[I "%compiler%" A܂B"                                     "ERROR! "%compiler%" is not found."
call     :select_writeln "̃ob`t@C "%compiler%" ̂tH_ɈړĂB"           "Move this BAT file to the folder including "%compiler%"."
goto end

:nocd
if "%~1" == "" goto noparam
if exist %~1\nul goto noparam
%compiler% < %1
exit /b

:noparam
echo.
call     :select_writeln "  v̑OɁÃRpC{ɓǂ𒲍܂B"                 "  Before benchmarking, check this compiler really works."
call     :select_writeln "+--------+------------+------------++----+"                                     "+--------+------------+------------++-------+"
call     :select_writeln ":Tv: ZpZq : ֌WZq :::"                                     ": Sample : Arithmetic : Relational :: TOTAL :"
call     :select_writeln "+--------+------------+------------++----+"                                     "+--------+------------+------------++-------+"

set n_errors=3

set output=0
if exist sample.txt for /f "skip=6 tokens=3" %%a in ('%compiler% ^< sample.txt') do call :forsub %%a
goto end_forsub
:forsub
    if %output% == 120 exit /b
    if %1 ==   1 if %output% ==  0 set output=%1
    if %1 ==   1 if %output% ==  1 set output=%1
    if %1 ==   2 if %output% ==  1 set output=%1
    if %1 ==   6 if %output% ==  2 set output=%1
    if %1 ==  24 if %output% ==  6 set output=%1
    if %1 == 120 if %output% == 24 set output=%1
    exit /b
:end_forsub
if     %output% == 120 call :select_write ":      " ":  Pass  "
if not %output% == 120 call :select_write ":   ~   " ":  Fail  "
if     %output% == 120 set /a n_errors-=1

call :test_program test_sample_arithmetic_operator.txt 17 "Compiler passed all the tests." "          " "     ~     " "    Pass    " "    Fail    "
set /a n_errors-=%test_program__result%
call :test_program test_sample_relational_operator.txt 14 "Compiler passed all the tests." "          " "     ~     " "    Pass    " "    Fail    "
set /a n_errors-=%test_program__result%

if     %n_errors% == 0 call :select_writeln                 "::  :"                                                                        ":: Pass  :"
if not %n_errors% == 0 call :select_writeln                 ":: ~ :"                                                                        ":: Fail  :"
call :select_writeln     "+--------+------------+------------++----+"                                     "+--------+------------+------------++-------+"
if not %n_errors% == 0 (
    echo.
    call :select_writeln "RpĆA퓮삵Ă܂Bv𒆎~܂B"                         "Compiler does not work correctly. Abort to benchmark."
    call :select_writeln "܂ŁB"                                                                     "Bye."
    goto end
)

echo.
call     :select_writeln "  ̌  C   VBScript ̑xrB"                                  "  Speed comparison of this language, C language and VBScript."
call     :select_writeln "+---------------------+-------------+----------+-----------+-----------------+" "+---------------------+-------------+----------+-----------+-----------------+"
call     :select_writeln ":                     :   ̌  :  C   :  VBScript :      x     :" ":                     :This Language:C Language: VBScript  :   Speed Ratio   :"
call     :select_writeln "+---------------------+-------------+----------+-----------+-----------------+" "+---------------------+-------------+----------+-----------+-----------------+"
if exist sample_sieve_of_eratosthenes.txt %compiler% < sample_sieve_of_eratosthenes.txt >nul
call    :time_3_programs ": GgXelX  :"                                                        ":Sieve of Eratosthenes:" sample_sieve_of_eratosthenes
call     :select_writeln "+---------------------+-------------+----------+-----------+-----------------+" "+---------------------+-------------+----------+-----------+-----------------+"
echo.
call     :select_writeln "B"                                                                         "Finished."

:end
call     :select_writeln "Iɂ͉L[Ă . . ."                                     "Press any key to exit . . ."
pause >NUL
exit /b


:select_write
if "%code_page%" == "932" (
    set /p select_write__dummy=%~1<nul
) else (
    set /p select_write__dummy=%~2<nul
)
exit /b

:select_writeln
if "%code_page%" == "932" (
    echo %~1
) else (
    echo %~2
)
exit /b

:test_program
set test_program__output=
set test_program__result=0
if exist %1 for /f "skip=%2 delims=" %%a in ('%compiler% ^< %1') do (
    if "%%a" == %3 set test_program__output=%%a
)
if     defined test_program__output call :select_write ":%~4" ":%~6"
if not defined test_program__output call :select_write ":%~5" ":%~7"
if     defined test_program__output set test_program__result=1
exit /b

:time_3_programs
call :time_program %1  10 12 %2  11 13 %3.txt                      "'%~nx0 %3.txt'"
set time_3_programs__tl=%time_program__result_ms%
call :time_program ":"  8  9 ":"  9 10 sample_c_and_vbs\%3_c.exe   "'sample_c_and_vbs\%3_c.exe'"
set time_3_programs__cl=%time_program__result_ms%
call :time_program ":"  9 10 ":" 10 11 sample_c_and_vbs\%3_vbs.vbs "'cscript.exe //nologo sample_c_and_vbs\%3_vbs.vbs'"
set time_3_programs__vb=%time_program__result_ms%
if    %time_3_programs__tl% == 0   set time_3_programs__tl=1
if    %time_3_programs__cl% == 0   set time_3_programs__cl=1
if    %time_3_programs__vb% == 0   set time_3_programs__vb=1
set /a time_3_programs__tl=10000000 / %time_3_programs__tl%
set /a time_3_programs__cl=10000000 / %time_3_programs__cl%
set /a time_3_programs__vb=10000000 / %time_3_programs__vb%
set    time_3_programs__mx=           %time_3_programs__tl%
if    %time_3_programs__mx%    lss    %time_3_programs__cl% set time_3_programs__mx=%time_3_programs__cl%
if    %time_3_programs__mx%    lss    %time_3_programs__vb% set time_3_programs__mx=%time_3_programs__vb%
set /a time_3_programs__tl=           %time_3_programs__tl%     *     1000    /     %time_3_programs__mx%
set /a time_3_programs__cl=           %time_3_programs__cl%     *     1000    /     %time_3_programs__mx%
set /a time_3_programs__vb=           %time_3_programs__vb%     *     1000    /     %time_3_programs__mx%
call :pad 3 "%time_3_programs__tl%" 4
call :pad 5 "%pad__result%:"
set time_3_programs__tl=%pad__result%
call :pad 5 "%time_3_programs__cl%"
set time_3_programs__cl=%pad__result%
call :pad 3 "%time_3_programs__vb%"
call :pad 5 ":%pad__result%"
set time_3_programs__cl=%time_3_programs__cl%%pad__result%
call :select_pad 16 "%time_3_programs__tl%%time_3_programs__cl%" 17 16 "%time_3_programs__tl%%time_3_programs__cl%" 17
call :select_writeln ":%select_pad__result%:" ":%select_pad__result%:"
exit /b

:time_program
set time_program__result_s=9999.999
if exist %7 for /f "skip=1 tokens=3" %%a in (%~8) do set time_program__result_s=%%a
for /f "delims=. tokens=1" %%a in ('echo %time_program__result_s%'       ) do set time_program__result_ms=%%a
for /f "delims=. tokens=2" %%a in ('echo %time_program__result_s%000.000') do set time_program__f=%%a
set time_program__result_s=%time_program__result_ms%.%time_program__f:~0,3%
set time_program__result_ms=%time_program__result_ms%%time_program__f:~0,3%
if %time_program__result_ms:~0,1% == 0 set time_program__result_ms=%time_program__result_ms:~1%
if %time_program__result_ms:~0,1% == 0 set time_program__result_ms=%time_program__result_ms:~1%
if %time_program__result_ms:~0,1% == 0 set time_program__result_ms=%time_program__result_ms:~1%
call :select_pad %2 "%time_program__result_s%b" %3 %5 "%time_program__result_s% s" %6
call :select_write "%~1%select_pad__result%" "%~4%select_pad__result%"
exit /b

:select_pad
if "%code_page%" == "932" (
    call :pad %1 %2 %3
) else (
    call :pad %4 %5 %6
)
set select_pad__result=%pad__result%
exit /b

:pad
set /a pad__left_to=%~1
set    pad__result=%~2
set    pad__right_to=0
if not "%~3" == "" set /a pad__right_to=%~3
:pad__loop_1
call :strlen "%pad__result%"
set /a pad__len=strlen__result-2
if %pad__len% lss %pad__left_to% (
    set pad__result= %pad__result%
    goto pad__loop_1
)
:pad__loop_2
call :strlen "%pad__result%"
set /a pad__len=strlen__result-2
if %pad__len% lss %pad__right_to% (
    set pad__result=%pad__result% 
    goto pad__loop_2
)
exit /b

:strlen
set strlen__str=%1
set strlen__result=0
:strlen__loop
if defined strlen__str (
    set strlen__str=%strlen__str:~1%
    set /a strlen__result+=1
    goto :strlen__loop
)
exit /b

