//  Sample program of sieve of Eratosthenes.
//
//  COPYRIGHT : Public domain
//
//  HOW TO BUILD :
//     > cl /Os /O1 /Gr /GS- sample_sieve_of_eratosthenes_c.c kernel32.lib
//                                   or
//     > gcc -Os -s -nostdlib -nodefaultlibs -fno-builtin
//           sample_sieve_of_eratosthenes_c.c
//           -Wl,--entry,_mainCRTStartup,--enable-stdcall-fixup -lkernel32
//
//     # Cannot use -fwhole-program option, because of the optimizer bug.

#include <windows.h>
#pragma comment(linker, "/subsystem:console")
#pragma comment(linker, "/nodefaultlib")
#pragma comment(linker, "/entry:\"mainCRTStartup\"")
#pragma comment(linker, "/merge:.rdata=.text")

int _stdcall mainCRTStartup() {
    int (_cdecl*printf_)(const char*, ...) = (int(_cdecl*)(const char*, ...))
        GetProcAddress(LoadLibraryA("msvcrt.dll"), "printf");
    unsigned long(_stdcall*timeGetTime_)(void)= (unsigned long(_stdcall*)(void))
        GetProcAddress(LoadLibraryA("winmm.dll"), "timeGetTime");
    static int sieve[4000*4000];
    int i, j, primes = 0;
    int c = timeGetTime_();

    for (i = 2; i < 4000*4000; ++i) sieve[i] = 1;
    for (i = 2; i < 4000; ++i) {
        if (sieve[i]) {
            for (j = i + i; j < 4000*4000; j += i) sieve[j] = 0;
        }
    }
    for (i = 0; i < 4000*4000; ++i) primes += sieve[i];

    c = timeGetTime_() - c;
    printf_("There are %d primes below 16,000,000.\nCalculated in ", primes);
    printf_("%d.%03d seconds.\n", c / 1000, c % 1000);
    return 0;
}


