Option Explicit

Dim sieve(16000000), i, j, primes, t, tm, msg, in_console, yn, title

in_console = instr(LCase(WScript.Fullname),"cscript.exe")
If in_console = 0 Then
    title = "Sample Sieve of Eratosthenes"
    yn = MsgBox("Count prime numbers below 16,000,000." & vbCrLf & _
        "It will take a bit of time. OK?", vbOKCancel, title)
    If yn = vbCancel Then WScript.Quit()
End If

t = Timer

For i = 2 To 16000000
    sieve(i) = 1
Next

For i = 2 To 4000
    If sieve(i) <> 0 Then
        For j = i + i To 16000000 Step i
            sieve(j) = 0
        Next
    End If
Next
primes = 0
For i = 0 To 16000000
    primes = primes + sieve(i)
Next

t = Timer - t
tm = Int((t - Int(t)) * 1000)
t  = Int(t)

msg = "There are " & primes & " primes below 16,000,000." & vbCrLf & _
      "Calculated in " & t & "." & tm \ 100 & _
      tm \ 10 Mod 10 & tm Mod 10 & " seconds."

If in_console = 0 Then
    MsgBox msg, 0, title
Else
    WScript.StdOut.WriteLine msg
End If

